## expcore.permission_groups module

Permission group making for factorio so you never have to make one by hand again [[-- Core Module - Permission Groups

### Dependencies

utils.game
utils.event
expcore.sudo

### Functions

Permissions_Groups.new_group(name) | Defines a new permission group that can have it actions set in the config
Permissions_Groups.get_group_by_name(name) | Returns the group with the given name, case sensitive
Permissions_Groups.get_group_from_player(player) | Returns the group that a player is in
Permissions_Groups.reload_permissions() | Reloads/creates all permission groups and sets them to they configured state
Permissions_Groups.lockdown_permissions(exempt) | Removes all permissions from every permission group except for "Default" and any passed as exempt
Permissions_Groups.set_player_group(player, group) | Sets a player's group to the one given, a player can only have one group at a time
Permissions_Groups._prototype:set_action(action, state) | Sets the allow state of an action for this group, used internally but is safe to use else where
Permissions_Groups._prototype:allow(actions) | Sets an action or actions to be allowed for this group even with disallow_all triggered, Do not use in runtime
Permissions_Groups._prototype:disallow(actions) | Sets an action or actions to be disallowed for this group even with allow_all triggered, Do not use in runtime
Permissions_Groups._prototype:allow_all() | Sets the default state for any actions not given to be allowed, useful with :disallow
Permissions_Groups._prototype:disallow_all() | Sets the default state for any action not given to be disallowed, useful with :allow
Permissions_Groups._prototype:is_allowed(action) | Returns if an input action is allowed for this group
Permissions_Groups._prototype:get_raw() | Returns the LuaPermissionGroup that was created with this group object, used internally
Permissions_Groups._prototype:create() | Creates or updates the permission group with the configured actions, used internally
Permissions_Groups._prototype:add_player(player) | Adds a player to this group
Permissions_Groups._prototype:remove_player(player) | Removes a player from this group
Permissions_Groups._prototype:get_players([online]) | Returns all player that are in this group with the option to filter to online/offline only
Permissions_Groups._prototype:print(message) | Prints a message to every player in this group

### Dependencies

# utils.game
# utils.event
# expcore.sudo

### Functions

# Permissions_Groups.new_group(name)

  Defines a new permission group that can have it actions set in the config

  Parameters:
  - name : (string) the name of the new group
  Returns:
  - (Permissions_Groups._prototype) the new group made with function to allow and disallow actions
# Permissions_Groups.get_group_by_name(name)

  Returns the group with the given name, case sensitive

  Parameters:
  - name : (string) the name of the group to get
  Returns:
  - (Permissions_Groups._prototype or nil) the group with that name or nil if non found
# Permissions_Groups.get_group_from_player(player)

  Returns the group that a player is in

  Parameters:
  - player : (LuaPlayer) the player to get the group of can be name index etc
  Returns:
  - (Permissions_Groups._prototype or nil) the group with that player or nil if non found
# Permissions_Groups.reload_permissions()

  Reloads/creates all permission groups and sets them to they configured state

# Permissions_Groups.lockdown_permissions(exempt)

  Removes all permissions from every permission group except for "Default" and any passed as exempt

  Parameters:
  - exempt : (string or Array) groups that you want to be except, "Default" is always exempt
  Returns:
  - (number) the number of groups that had they permissions removed
# Permissions_Groups.set_player_group(player, group)

  Sets a player's group to the one given, a player can only have one group at a time

  Parameters:
  - player : (LuaPlayer) the player to effect can be name index etc
  - group : (string) the name of the group to give to the player
  Returns:
  - (boolean) true if the player was added successfully, false other wise
# Permissions_Groups._prototype:set_action(action, state)

  Sets the allow state of an action for this group, used internally but is safe to use else where

  Parameters:
  - action : (string or defines.input_action) the action that you want to set the state of
  - state : (boolean) the state that you want to set it to, true = allow, false = disallow
  Returns:
  - (Permissions_Groups._prototype) returns self so function can be chained
# Permissions_Groups._prototype:allow(actions)

  Sets an action or actions to be allowed for this group even with disallow_all triggered, Do not use in runtime

  Parameters:
  - actions : (string or Array) the action or actions that you want to allow for this group
  Returns:
  - (Permissions_Groups._prototype) returns self so function can be chained
# Permissions_Groups._prototype:disallow(actions)

  Sets an action or actions to be disallowed for this group even with allow_all triggered, Do not use in runtime

  Parameters:
  - actions : (string or Array) the action or actions that you want to disallow for this group
  Returns:
  - (Permissions_Groups._prototype) returns self so function can be chained
# Permissions_Groups._prototype:allow_all()

  Sets the default state for any actions not given to be allowed, useful with :disallow

  Returns:
  - (Permissions_Groups._prototype) returns self so function can be chained
# Permissions_Groups._prototype:disallow_all()

  Sets the default state for any action not given to be disallowed, useful with :allow

  Returns:
  - (Permissions_Groups._prototype) returns self so function can be chained
# Permissions_Groups._prototype:is_allowed(action)

  Returns if an input action is allowed for this group

  Parameters:
  - action : (string or defines.input_action) the action that you want to test for
  Returns:
  - (boolean) true if the group is allowed the action, false other wise
# Permissions_Groups._prototype:get_raw()

  Returns the LuaPermissionGroup that was created with this group object, used internally

  Returns:
  - (LuaPermissionGroup) the raw lua permission group
# Permissions_Groups._prototype:create()

  Creates or updates the permission group with the configured actions, used internally

  Returns:
  - (LuaPermissionGroup) the permission group that was created
# Permissions_Groups._prototype:add_player(player)

  Adds a player to this group

  Parameters:
  - player : (LuaPlayer) LuaPlayer the player you want to add to this group can be name or index etc
  Returns:
  - (boolean) true if the player was added successfully, false other wise
# Permissions_Groups._prototype:remove_player(player)

  Removes a player from this group

  Parameters:
  - player : (LuaPlayer) LuaPlayer the player you want to remove from this group can be name or index etc
  Returns:
  - (boolean) true if the player was removed successfully, false other wise
# Permissions_Groups._prototype:get_players([online])

  Returns all player that are in this group with the option to filter to online/offline only

  Parameters:
  - online : (boolean) if nil returns all players, if true online players only, if false returns online players only (optional)
  Returns:
  - (table) a table of players that are in this group; filtered if online param is given
# Permissions_Groups._prototype:print(message)

  Prints a message to every player in this group

  Parameters:
  - message : (string) the message that you want to send to the players
  Returns:
  - (number) the number of players that received the message